import java.math.BigInteger;
import static java.math.BigInteger.*;

public class LeftFactorial {
	BigInteger lf(int n) {
		if(n <= 0 || n >= Short.MAX_VALUE) {
			return ZERO;
		} else if(n == 1) {
			return ONE;
		} else {
			return sub(mul(n, lf(n - 1)), mul(n - 1, lf(n - 2)));
		}
	}
	
	BigInteger[] dpArr = new BigInteger[Short.MAX_VALUE];
	
	BigInteger dp(int n) {
		if(n <= 0 || n >= Short.MAX_VALUE) {
			return ZERO;
		} else if(n == 1) {
			return ONE;
		} else {
			if(dpArr[n] == null)
				dpArr[n] = sub(mul(n, dp(n - 1)), mul(n - 1, dp(n - 2)));
			
			return dpArr[n];
		}
	}
	
	private static BigInteger mul(int n, BigInteger m) {
		return new BigInteger(Integer.toString(n)).multiply(m);
	}
	
	private static BigInteger sub(BigInteger n, BigInteger m) {
		return n.subtract(m);
	}
	
	public static void main(String[] args) {
		LeftFactorial myLF = new LeftFactorial();
		System.out.println(myLF.lf(10));
		System.out.println(myLF.dp(10));
	}
}
